using System;
using System.Net;
using System.Net.Sockets;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

using AnimalLibrary;

class AnimalReceiver
{
	const int SERVER_PORT = 10000;

	static void Main(string[] args)
	{
		TcpListener tcpListener = new TcpListener(IPAddress.Any, SERVER_PORT);
		tcpListener.Start();
		Console.WriteLine("Server started.");

		while (true)
		{
			TcpClient client = tcpListener.AcceptTcpClient();
			try
			{
				IFormatter formatter = new BinaryFormatter();
				NetworkStream stream = client.GetStream();
				using (stream)
				{
					Animal animal = (Animal) formatter.Deserialize(stream);
					Console.WriteLine("Received animal: {0}", animal);
				}
			}
			finally
			{
				client.Close();
			}
		}
	}
}