using System;
using System.IO;
using System.Text;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

[Serializable]
class SomeClass
{
	public StringBuilder mSomeStringBuilder;
	public string mSomeString;
	public object mSomeObject;
	public int mSomeInt;
	public SomeClass mSomeClass;
}

class DeepCopyDemo
{
	static void Main()
	{
		SomeClass original = new SomeClass();
		original.mSomeString = "Аз съм обикновено стрингче.";
		original.mSomeStringBuilder = new StringBuilder(
			"Защо този тип ме занимава с тия глупости?!");
		original.mSomeObject = new object();
		original.mSomeInt = 12345;
		original.mSomeClass = original;

		SomeClass copy = (SomeClass) DeepCopyDemo.DeepCopy(original);

		Console.WriteLine("copy.mSomeString={0}", copy.mSomeString );
		Console.WriteLine("copy.mSomeStringBuilder={0}", copy.mSomeStringBuilder);
		Console.WriteLine("copy.mSomeObject={0}", copy.mSomeObject);
		Console.WriteLine("copy.mSomeInt={0}\n", copy.mSomeInt );

		Console.WriteLine("copy.mSomeClass == copy ? {0}\n", 
			Object.ReferenceEquals(copy.mSomeClass, copy) );

		Console.WriteLine("copy.mSomeClass == original ? {0}\n", 
			Object.ReferenceEquals(copy.mSomeClass, original) );

		Console.WriteLine("Identical instances? {0}",
			Object.ReferenceEquals(copy, original));
		Console.WriteLine("Equal mSomeString? {0}", 
			copy.mSomeString == original.mSomeString);
		Console.WriteLine("Equal mSomeString by reference? {0}", 
			Object.ReferenceEquals(copy.mSomeString, original.mSomeString));
		Console.WriteLine("Equal mSomeStringBuilder? {0}",
			copy.mSomeStringBuilder == original.mSomeStringBuilder);
		Console.WriteLine("Equal mSomeStringBuilder.ToString()? {0}",
			copy.mSomeStringBuilder.ToString() == original.mSomeStringBuilder.ToString());
		Console.WriteLine("Equal mSomeObject? {0}",
			copy.mSomeObject == original.mSomeObject );
		Console.WriteLine("Equal mSomeInt? {0}",
			copy.mSomeInt == original.mSomeInt);
	}

	public static object DeepCopy(object aSourceObject)
	{
		IFormatter formatter = new BinaryFormatter();
		formatter.Context = new StreamingContext(StreamingContextStates.Clone);
		Stream memStream = new MemoryStream();
		formatter.Serialize(memStream, aSourceObject);
		memStream.Position = 0;
		object resultObject = formatter.Deserialize(memStream);
		return resultObject;
	}
}
