using System;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace Demo_4_IDeserializationCallback
{
	[Serializable]
	class Circle //: IDeserializationCallback
	{
		private double mRadius;
		
		[NonSerialized]
		private double mPerimeter;
		
		[NonSerialized]
		private double mArea;
		
		public Circle(double aRadius)
		{
			mRadius = aRadius;
			InitInternalState();
		}

		private void InitInternalState()
		{
			mPerimeter = 2 * Math.PI * mRadius;
			mArea = Math.PI * mRadius * mRadius;
		}
/*
		void IDeserializationCallback.OnDeserialization(object aSender)
		{
			InitInternalState();
		}
*/
		public override string ToString()
		{
			string result= String.Format(
				"Radius: {0}, Perimeter: {1}, Area: {2}",
				mRadius, mPerimeter, mArea);
			return result;
		}
	}

	class IDeserializationCallbackDemo
	{
		static void Main()
		{
			Circle circle = new Circle(3.0);
			Console.WriteLine("Original circle: {0}", circle);

			IFormatter formatter = new BinaryFormatter();
			Stream stream = new MemoryStream();
			formatter.Serialize(stream, circle);
			stream.Position = 0;
			Circle newCircle = (Circle) formatter.Deserialize(stream);

			Console.WriteLine("New circle: {0}", newCircle);
		}
	}
}