using System;
using System.IO;
using System.Xml.Serialization;

public class Student
{
	private string mName;
	private int mAge;

	public string Name
	{
		get { return mName; }
		set { mName = value; }
	}

	public int Age
	{
		get { return mAge; }
		set { mAge = value; }
	}

	public override string ToString()
	{
		string result = String.Format("(Name: {0}, Age: {1})", Name, Age);
		return result;
	}

}

class XmlSerializationDemo
{
	static void Main()
	{
		Student student = new Student();
		student.Name = " ";
		student.Age = 99;
		Console.WriteLine("Original = {0}", student);
		
		// Serialize student object to "student.xml" file
		XmlSerializer xmlSerializer = 
			new XmlSerializer(typeof(Student));
		FileStream outputStream = File.OpenWrite("student.xml");
		using (outputStream)
		{
			xmlSerializer.Serialize(outputStream, student);
		}
		Console.WriteLine("Student serialized.");

		// Deserialize student object from "student.xml" file
		FileStream inputStream = File.OpenRead("student.xml");
		using (inputStream)
		{
			Student deserializedStudent = 
				(Student) xmlSerializer.Deserialize(inputStream);
			Console.WriteLine("Student deserialized.");
			Console.WriteLine("Deserialized = {0}", deserializedStudent);
		}
	}
}
